t / test-lib.shon commit Merge branch 'ef/setenv-putenv' (340c54a)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset EMAIL
  47unset LANGUAGE
  48unset $(perl -e '
  49        my @env = keys %ENV;
  50        my $ok = join("|", qw(
  51                TRACE
  52                DEBUG
  53                USE_LOOKUP
  54                TEST
  55                .*_TEST
  56                PROVE
  57                VALGRIND
  58        ));
  59        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  60        print join("\n", @vars);
  61')
  62GIT_AUTHOR_EMAIL=author@example.com
  63GIT_AUTHOR_NAME='A U Thor'
  64GIT_COMMITTER_EMAIL=committer@example.com
  65GIT_COMMITTER_NAME='C O Mitter'
  66GIT_MERGE_VERBOSITY=5
  67export GIT_MERGE_VERBOSITY
  68export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  69export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  70export EDITOR
  71
  72# Protect ourselves from common misconfiguration to export
  73# CDPATH into the environment
  74unset CDPATH
  75
  76unset GREP_OPTIONS
  77
  78case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  79        1|2|true)
  80                echo "* warning: Some tests will not work if GIT_TRACE" \
  81                        "is set as to trace on STDERR ! *"
  82                echo "* warning: Please set GIT_TRACE to something" \
  83                        "other than 1, 2 or true ! *"
  84                ;;
  85esac
  86
  87# Convenience
  88#
  89# A regexp to match 5 and 40 hexdigits
  90_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  91_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  92
  93# Zero SHA-1
  94_z40=0000000000000000000000000000000000000000
  95
  96# Line feed
  97LF='
  98'
  99
 100# Each test should start with something like this, after copyright notices:
 101#
 102# test_description='Description of this test...
 103# This test checks if command xyzzy does the right thing...
 104# '
 105# . ./test-lib.sh
 106[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 107                TERM=$ORIGINAL_TERM &&
 108                export TERM &&
 109                [ -t 1 ] &&
 110                tput bold >/dev/null 2>&1 &&
 111                tput setaf 1 >/dev/null 2>&1 &&
 112                tput sgr0 >/dev/null 2>&1
 113        ) &&
 114        color=t
 115
 116while test "$#" -ne 0
 117do
 118        case "$1" in
 119        -d|--d|--de|--deb|--debu|--debug)
 120                debug=t; shift ;;
 121        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 122                immediate=t; shift ;;
 123        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 124                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 125        -h|--h|--he|--hel|--help)
 126                help=t; shift ;;
 127        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 128                verbose=t; shift ;;
 129        -q|--q|--qu|--qui|--quie|--quiet)
 130                # Ignore --quiet under a TAP::Harness. Saying how many tests
 131                # passed without the ok/not ok details is always an error.
 132                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 133        --with-dashes)
 134                with_dashes=t; shift ;;
 135        --no-color)
 136                color=; shift ;;
 137        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 138                valgrind=t; verbose=t; shift ;;
 139        --tee)
 140                shift ;; # was handled already
 141        --root=*)
 142                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 143                shift ;;
 144        *)
 145                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 146        esac
 147done
 148
 149if test -n "$color"; then
 150        say_color () {
 151                (
 152                TERM=$ORIGINAL_TERM
 153                export TERM
 154                case "$1" in
 155                        error) tput bold; tput setaf 1;; # bold red
 156                        skip)  tput bold; tput setaf 2;; # bold green
 157                        pass)  tput setaf 2;;            # green
 158                        info)  tput setaf 3;;            # brown
 159                        *) test -n "$quiet" && return;;
 160                esac
 161                shift
 162                printf "%s" "$*"
 163                tput sgr0
 164                echo
 165                )
 166        }
 167else
 168        say_color() {
 169                test -z "$1" && test -n "$quiet" && return
 170                shift
 171                echo "$*"
 172        }
 173fi
 174
 175error () {
 176        say_color error "error: $*"
 177        GIT_EXIT_OK=t
 178        exit 1
 179}
 180
 181say () {
 182        say_color info "$*"
 183}
 184
 185test "${test_description}" != "" ||
 186error "Test script did not set test_description."
 187
 188if test "$help" = "t"
 189then
 190        echo "$test_description"
 191        exit 0
 192fi
 193
 194exec 5>&1
 195if test "$verbose" = "t"
 196then
 197        exec 4>&2 3>&1
 198else
 199        exec 4>/dev/null 3>/dev/null
 200fi
 201
 202test_failure=0
 203test_count=0
 204test_fixed=0
 205test_broken=0
 206test_success=0
 207
 208test_external_has_tap=0
 209
 210die () {
 211        code=$?
 212        if test -n "$GIT_EXIT_OK"
 213        then
 214                exit $code
 215        else
 216                echo >&5 "FATAL: Unexpected exit with code $code"
 217                exit 1
 218        fi
 219}
 220
 221GIT_EXIT_OK=
 222trap 'die' EXIT
 223
 224# The semantics of the editor variables are that of invoking
 225# sh -c "$EDITOR \"$@\"" files ...
 226#
 227# If our trash directory contains shell metacharacters, they will be
 228# interpreted if we just set $EDITOR directly, so do a little dance with
 229# environment variables to work around this.
 230#
 231# In particular, quoting isn't enough, as the path may contain the same quote
 232# that we're using.
 233test_set_editor () {
 234        FAKE_EDITOR="$1"
 235        export FAKE_EDITOR
 236        EDITOR='"$FAKE_EDITOR"'
 237        export EDITOR
 238}
 239
 240test_decode_color () {
 241        awk '
 242                function name(n) {
 243                        if (n == 0) return "RESET";
 244                        if (n == 1) return "BOLD";
 245                        if (n == 30) return "BLACK";
 246                        if (n == 31) return "RED";
 247                        if (n == 32) return "GREEN";
 248                        if (n == 33) return "YELLOW";
 249                        if (n == 34) return "BLUE";
 250                        if (n == 35) return "MAGENTA";
 251                        if (n == 36) return "CYAN";
 252                        if (n == 37) return "WHITE";
 253                        if (n == 40) return "BLACK";
 254                        if (n == 41) return "BRED";
 255                        if (n == 42) return "BGREEN";
 256                        if (n == 43) return "BYELLOW";
 257                        if (n == 44) return "BBLUE";
 258                        if (n == 45) return "BMAGENTA";
 259                        if (n == 46) return "BCYAN";
 260                        if (n == 47) return "BWHITE";
 261                }
 262                {
 263                        while (match($0, /\033\[[0-9;]*m/) != 0) {
 264                                printf "%s<", substr($0, 1, RSTART-1);
 265                                codes = substr($0, RSTART+2, RLENGTH-3);
 266                                if (length(codes) == 0)
 267                                        printf "%s", name(0)
 268                                else {
 269                                        n = split(codes, ary, ";");
 270                                        sep = "";
 271                                        for (i = 1; i <= n; i++) {
 272                                                printf "%s%s", sep, name(ary[i]);
 273                                                sep = ";"
 274                                        }
 275                                }
 276                                printf ">";
 277                                $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
 278                        }
 279                        print
 280                }
 281        '
 282}
 283
 284nul_to_q () {
 285        perl -pe 'y/\000/Q/'
 286}
 287
 288q_to_nul () {
 289        perl -pe 'y/Q/\000/'
 290}
 291
 292q_to_cr () {
 293        tr Q '\015'
 294}
 295
 296q_to_tab () {
 297        tr Q '\011'
 298}
 299
 300append_cr () {
 301        sed -e 's/$/Q/' | tr Q '\015'
 302}
 303
 304remove_cr () {
 305        tr '\015' Q | sed -e 's/Q$//'
 306}
 307
 308# In some bourne shell implementations, the "unset" builtin returns
 309# nonzero status when a variable to be unset was not set in the first
 310# place.
 311#
 312# Use sane_unset when that should not be considered an error.
 313
 314sane_unset () {
 315        unset "$@"
 316        return 0
 317}
 318
 319test_tick () {
 320        if test -z "${test_tick+set}"
 321        then
 322                test_tick=1112911993
 323        else
 324                test_tick=$(($test_tick + 60))
 325        fi
 326        GIT_COMMITTER_DATE="$test_tick -0700"
 327        GIT_AUTHOR_DATE="$test_tick -0700"
 328        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 329}
 330
 331# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 332#
 333# This will commit a file with the given contents and the given commit
 334# message.  It will also add a tag with <message> as name.
 335#
 336# Both <file> and <contents> default to <message>.
 337
 338test_commit () {
 339        file=${2:-"$1.t"}
 340        echo "${3-$1}" > "$file" &&
 341        git add "$file" &&
 342        test_tick &&
 343        git commit -m "$1" &&
 344        git tag "$1"
 345}
 346
 347# Call test_merge with the arguments "<message> <commit>", where <commit>
 348# can be a tag pointing to the commit-to-merge.
 349
 350test_merge () {
 351        test_tick &&
 352        git merge -m "$1" "$2" &&
 353        git tag "$1"
 354}
 355
 356# This function helps systems where core.filemode=false is set.
 357# Use it instead of plain 'chmod +x' to set or unset the executable bit
 358# of a file in the working directory and add it to the index.
 359
 360test_chmod () {
 361        chmod "$@" &&
 362        git update-index --add "--chmod=$@"
 363}
 364
 365# Unset a configuration variable, but don't fail if it doesn't exist.
 366test_unconfig () {
 367        git config --unset-all "$@"
 368        config_status=$?
 369        case "$config_status" in
 370        5) # ok, nothing to unset
 371                config_status=0
 372                ;;
 373        esac
 374        return $config_status
 375}
 376
 377# Set git config, automatically unsetting it after the test is over.
 378test_config () {
 379        test_when_finished "test_unconfig '$1'" &&
 380        git config "$@"
 381}
 382
 383test_config_global () {
 384        test_when_finished "test_unconfig --global '$1'" &&
 385        git config --global "$@"
 386}
 387
 388# Use test_set_prereq to tell that a particular prerequisite is available.
 389# The prerequisite can later be checked for in two ways:
 390#
 391# - Explicitly using test_have_prereq.
 392#
 393# - Implicitly by specifying the prerequisite tag in the calls to
 394#   test_expect_{success,failure,code}.
 395#
 396# The single parameter is the prerequisite tag (a simple word, in all
 397# capital letters by convention).
 398
 399test_set_prereq () {
 400        satisfied="$satisfied$1 "
 401}
 402satisfied=" "
 403
 404test_have_prereq () {
 405        # prerequisites can be concatenated with ','
 406        save_IFS=$IFS
 407        IFS=,
 408        set -- $*
 409        IFS=$save_IFS
 410
 411        total_prereq=0
 412        ok_prereq=0
 413        missing_prereq=
 414
 415        for prerequisite
 416        do
 417                total_prereq=$(($total_prereq + 1))
 418                case $satisfied in
 419                *" $prerequisite "*)
 420                        ok_prereq=$(($ok_prereq + 1))
 421                        ;;
 422                *)
 423                        # Keep a list of missing prerequisites
 424                        if test -z "$missing_prereq"
 425                        then
 426                                missing_prereq=$prerequisite
 427                        else
 428                                missing_prereq="$prerequisite,$missing_prereq"
 429                        fi
 430                esac
 431        done
 432
 433        test $total_prereq = $ok_prereq
 434}
 435
 436test_declared_prereq () {
 437        case ",$test_prereq," in
 438        *,$1,*)
 439                return 0
 440                ;;
 441        esac
 442        return 1
 443}
 444
 445# You are not expected to call test_ok_ and test_failure_ directly, use
 446# the text_expect_* functions instead.
 447
 448test_ok_ () {
 449        test_success=$(($test_success + 1))
 450        say_color "" "ok $test_count - $@"
 451}
 452
 453test_failure_ () {
 454        test_failure=$(($test_failure + 1))
 455        say_color error "not ok - $test_count $1"
 456        shift
 457        echo "$@" | sed -e 's/^/#       /'
 458        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 459}
 460
 461test_known_broken_ok_ () {
 462        test_fixed=$(($test_fixed+1))
 463        say_color "" "ok $test_count - $@ # TODO known breakage"
 464}
 465
 466test_known_broken_failure_ () {
 467        test_broken=$(($test_broken+1))
 468        say_color skip "not ok $test_count - $@ # TODO known breakage"
 469}
 470
 471test_debug () {
 472        test "$debug" = "" || eval "$1"
 473}
 474
 475test_eval_ () {
 476        # This is a separate function because some tests use
 477        # "return" to end a test_expect_success block early.
 478        eval >&3 2>&4 "$*"
 479}
 480
 481test_run_ () {
 482        test_cleanup=:
 483        expecting_failure=$2
 484        test_eval_ "$1"
 485        eval_ret=$?
 486
 487        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 488        then
 489                test_eval_ "$test_cleanup"
 490        fi
 491        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 492                echo ""
 493        fi
 494        return "$eval_ret"
 495}
 496
 497test_skip () {
 498        test_count=$(($test_count+1))
 499        to_skip=
 500        for skp in $GIT_SKIP_TESTS
 501        do
 502                case $this_test.$test_count in
 503                $skp)
 504                        to_skip=t
 505                        break
 506                esac
 507        done
 508        if test -z "$to_skip" && test -n "$test_prereq" &&
 509           ! test_have_prereq "$test_prereq"
 510        then
 511                to_skip=t
 512        fi
 513        case "$to_skip" in
 514        t)
 515                of_prereq=
 516                if test "$missing_prereq" != "$test_prereq"
 517                then
 518                        of_prereq=" of $test_prereq"
 519                fi
 520
 521                say_color skip >&3 "skipping test: $@"
 522                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 523                : true
 524                ;;
 525        *)
 526                false
 527                ;;
 528        esac
 529}
 530
 531test_expect_failure () {
 532        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 533        test "$#" = 2 ||
 534        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 535        export test_prereq
 536        if ! test_skip "$@"
 537        then
 538                say >&3 "checking known breakage: $2"
 539                if test_run_ "$2" expecting_failure
 540                then
 541                        test_known_broken_ok_ "$1"
 542                else
 543                        test_known_broken_failure_ "$1"
 544                fi
 545        fi
 546        echo >&3 ""
 547}
 548
 549test_expect_success () {
 550        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 551        test "$#" = 2 ||
 552        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 553        export test_prereq
 554        if ! test_skip "$@"
 555        then
 556                say >&3 "expecting success: $2"
 557                if test_run_ "$2"
 558                then
 559                        test_ok_ "$1"
 560                else
 561                        test_failure_ "$@"
 562                fi
 563        fi
 564        echo >&3 ""
 565}
 566
 567# test_external runs external test scripts that provide continuous
 568# test output about their progress, and succeeds/fails on
 569# zero/non-zero exit code.  It outputs the test output on stdout even
 570# in non-verbose mode, and announces the external script with "# run
 571# <n>: ..." before running it.  When providing relative paths, keep in
 572# mind that all scripts run in "trash directory".
 573# Usage: test_external description command arguments...
 574# Example: test_external 'Perl API' perl ../path/to/test.pl
 575test_external () {
 576        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 577        test "$#" = 3 ||
 578        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 579        descr="$1"
 580        shift
 581        export test_prereq
 582        if ! test_skip "$descr" "$@"
 583        then
 584                # Announce the script to reduce confusion about the
 585                # test output that follows.
 586                say_color "" "# run $test_count: $descr ($*)"
 587                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 588                # to be able to use them in script
 589                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 590                # Run command; redirect its stderr to &4 as in
 591                # test_run_, but keep its stdout on our stdout even in
 592                # non-verbose mode.
 593                "$@" 2>&4
 594                if [ "$?" = 0 ]
 595                then
 596                        if test $test_external_has_tap -eq 0; then
 597                                test_ok_ "$descr"
 598                        else
 599                                say_color "" "# test_external test $descr was ok"
 600                                test_success=$(($test_success + 1))
 601                        fi
 602                else
 603                        if test $test_external_has_tap -eq 0; then
 604                                test_failure_ "$descr" "$@"
 605                        else
 606                                say_color error "# test_external test $descr failed: $@"
 607                                test_failure=$(($test_failure + 1))
 608                        fi
 609                fi
 610        fi
 611}
 612
 613# Like test_external, but in addition tests that the command generated
 614# no output on stderr.
 615test_external_without_stderr () {
 616        # The temporary file has no (and must have no) security
 617        # implications.
 618        tmp=${TMPDIR:-/tmp}
 619        stderr="$tmp/git-external-stderr.$$.tmp"
 620        test_external "$@" 4> "$stderr"
 621        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 622        descr="no stderr: $1"
 623        shift
 624        say >&3 "# expecting no stderr from previous command"
 625        if [ ! -s "$stderr" ]; then
 626                rm "$stderr"
 627
 628                if test $test_external_has_tap -eq 0; then
 629                        test_ok_ "$descr"
 630                else
 631                        say_color "" "# test_external_without_stderr test $descr was ok"
 632                        test_success=$(($test_success + 1))
 633                fi
 634        else
 635                if [ "$verbose" = t ]; then
 636                        output=`echo; echo "# Stderr is:"; cat "$stderr"`
 637                else
 638                        output=
 639                fi
 640                # rm first in case test_failure exits.
 641                rm "$stderr"
 642                if test $test_external_has_tap -eq 0; then
 643                        test_failure_ "$descr" "$@" "$output"
 644                else
 645                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 646                        test_failure=$(($test_failure + 1))
 647                fi
 648        fi
 649}
 650
 651# debugging-friendly alternatives to "test [-f|-d|-e]"
 652# The commands test the existence or non-existence of $1. $2 can be
 653# given to provide a more precise diagnosis.
 654test_path_is_file () {
 655        if ! [ -f "$1" ]
 656        then
 657                echo "File $1 doesn't exist. $*"
 658                false
 659        fi
 660}
 661
 662test_path_is_dir () {
 663        if ! [ -d "$1" ]
 664        then
 665                echo "Directory $1 doesn't exist. $*"
 666                false
 667        fi
 668}
 669
 670test_path_is_missing () {
 671        if [ -e "$1" ]
 672        then
 673                echo "Path exists:"
 674                ls -ld "$1"
 675                if [ $# -ge 1 ]; then
 676                        echo "$*"
 677                fi
 678                false
 679        fi
 680}
 681
 682# test_line_count checks that a file has the number of lines it
 683# ought to. For example:
 684#
 685#       test_expect_success 'produce exactly one line of output' '
 686#               do something >output &&
 687#               test_line_count = 1 output
 688#       '
 689#
 690# is like "test $(wc -l <output) = 1" except that it passes the
 691# output through when the number of lines is wrong.
 692
 693test_line_count () {
 694        if test $# != 3
 695        then
 696                error "bug in the test script: not 3 parameters to test_line_count"
 697        elif ! test $(wc -l <"$3") "$1" "$2"
 698        then
 699                echo "test_line_count: line count for $3 !$1 $2"
 700                cat "$3"
 701                return 1
 702        fi
 703}
 704
 705# This is not among top-level (test_expect_success | test_expect_failure)
 706# but is a prefix that can be used in the test script, like:
 707#
 708#       test_expect_success 'complain and die' '
 709#           do something &&
 710#           do something else &&
 711#           test_must_fail git checkout ../outerspace
 712#       '
 713#
 714# Writing this as "! git checkout ../outerspace" is wrong, because
 715# the failure could be due to a segv.  We want a controlled failure.
 716
 717test_must_fail () {
 718        "$@"
 719        exit_code=$?
 720        if test $exit_code = 0; then
 721                echo >&2 "test_must_fail: command succeeded: $*"
 722                return 1
 723        elif test $exit_code -gt 129 -a $exit_code -le 192; then
 724                echo >&2 "test_must_fail: died by signal: $*"
 725                return 1
 726        elif test $exit_code = 127; then
 727                echo >&2 "test_must_fail: command not found: $*"
 728                return 1
 729        fi
 730        return 0
 731}
 732
 733# Similar to test_must_fail, but tolerates success, too.  This is
 734# meant to be used in contexts like:
 735#
 736#       test_expect_success 'some command works without configuration' '
 737#               test_might_fail git config --unset all.configuration &&
 738#               do something
 739#       '
 740#
 741# Writing "git config --unset all.configuration || :" would be wrong,
 742# because we want to notice if it fails due to segv.
 743
 744test_might_fail () {
 745        "$@"
 746        exit_code=$?
 747        if test $exit_code -gt 129 -a $exit_code -le 192; then
 748                echo >&2 "test_might_fail: died by signal: $*"
 749                return 1
 750        elif test $exit_code = 127; then
 751                echo >&2 "test_might_fail: command not found: $*"
 752                return 1
 753        fi
 754        return 0
 755}
 756
 757# Similar to test_must_fail and test_might_fail, but check that a
 758# given command exited with a given exit code. Meant to be used as:
 759#
 760#       test_expect_success 'Merge with d/f conflicts' '
 761#               test_expect_code 1 git merge "merge msg" B master
 762#       '
 763
 764test_expect_code () {
 765        want_code=$1
 766        shift
 767        "$@"
 768        exit_code=$?
 769        if test $exit_code = $want_code
 770        then
 771                return 0
 772        fi
 773
 774        echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 775        return 1
 776}
 777
 778# test_cmp is a helper function to compare actual and expected output.
 779# You can use it like:
 780#
 781#       test_expect_success 'foo works' '
 782#               echo expected >expected &&
 783#               foo >actual &&
 784#               test_cmp expected actual
 785#       '
 786#
 787# This could be written as either "cmp" or "diff -u", but:
 788# - cmp's output is not nearly as easy to read as diff -u
 789# - not all diff versions understand "-u"
 790
 791test_cmp() {
 792        $GIT_TEST_CMP "$@"
 793}
 794
 795# This function can be used to schedule some commands to be run
 796# unconditionally at the end of the test to restore sanity:
 797#
 798#       test_expect_success 'test core.capslock' '
 799#               git config core.capslock true &&
 800#               test_when_finished "git config --unset core.capslock" &&
 801#               hello world
 802#       '
 803#
 804# That would be roughly equivalent to
 805#
 806#       test_expect_success 'test core.capslock' '
 807#               git config core.capslock true &&
 808#               hello world
 809#               git config --unset core.capslock
 810#       '
 811#
 812# except that the greeting and config --unset must both succeed for
 813# the test to pass.
 814#
 815# Note that under --immediate mode, no clean-up is done to help diagnose
 816# what went wrong.
 817
 818test_when_finished () {
 819        test_cleanup="{ $*
 820                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 821}
 822
 823# Most tests can use the created repository, but some may need to create more.
 824# Usage: test_create_repo <directory>
 825test_create_repo () {
 826        test "$#" = 1 ||
 827        error "bug in the test script: not 1 parameter to test-create-repo"
 828        repo="$1"
 829        mkdir -p "$repo"
 830        (
 831                cd "$repo" || error "Cannot setup test environment"
 832                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 833                error "cannot run git init -- have you built things yet?"
 834                mv .git/hooks .git/hooks-disabled
 835        ) || exit
 836}
 837
 838test_done () {
 839        GIT_EXIT_OK=t
 840
 841        if test -z "$HARNESS_ACTIVE"; then
 842                test_results_dir="$TEST_DIRECTORY/test-results"
 843                mkdir -p "$test_results_dir"
 844                test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 845
 846                cat >>"$test_results_path" <<-EOF
 847                total $test_count
 848                success $test_success
 849                fixed $test_fixed
 850                broken $test_broken
 851                failed $test_failure
 852
 853                EOF
 854        fi
 855
 856        if test "$test_fixed" != 0
 857        then
 858                say_color pass "# fixed $test_fixed known breakage(s)"
 859        fi
 860        if test "$test_broken" != 0
 861        then
 862                say_color error "# still have $test_broken known breakage(s)"
 863                msg="remaining $(($test_count-$test_broken)) test(s)"
 864        else
 865                msg="$test_count test(s)"
 866        fi
 867        case "$test_failure" in
 868        0)
 869                # Maybe print SKIP message
 870                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 871
 872                if test $test_external_has_tap -eq 0; then
 873                        say_color pass "# passed all $msg"
 874                        say "1..$test_count$skip_all"
 875                fi
 876
 877                test -d "$remove_trash" &&
 878                cd "$(dirname "$remove_trash")" &&
 879                rm -rf "$(basename "$remove_trash")"
 880
 881                exit 0 ;;
 882
 883        *)
 884                if test $test_external_has_tap -eq 0; then
 885                        say_color error "# failed $test_failure among $msg"
 886                        say "1..$test_count"
 887                fi
 888
 889                exit 1 ;;
 890
 891        esac
 892}
 893
 894# Test the binaries we have just built.  The tests are kept in
 895# t/ subdirectory and are run in 'trash directory' subdirectory.
 896if test -z "$TEST_DIRECTORY"
 897then
 898        # We allow tests to override this, in case they want to run tests
 899        # outside of t/, e.g. for running tests on the test library
 900        # itself.
 901        TEST_DIRECTORY=$(pwd)
 902fi
 903GIT_BUILD_DIR="$TEST_DIRECTORY"/..
 904
 905if test -n "$valgrind"
 906then
 907        make_symlink () {
 908                test -h "$2" &&
 909                test "$1" = "$(readlink "$2")" || {
 910                        # be super paranoid
 911                        if mkdir "$2".lock
 912                        then
 913                                rm -f "$2" &&
 914                                ln -s "$1" "$2" &&
 915                                rm -r "$2".lock
 916                        else
 917                                while test -d "$2".lock
 918                                do
 919                                        say "Waiting for lock on $2."
 920                                        sleep 1
 921                                done
 922                        fi
 923                }
 924        }
 925
 926        make_valgrind_symlink () {
 927                # handle only executables, unless they are shell libraries that
 928                # need to be in the exec-path.  We will just use "#!" as a
 929                # guess for a shell-script, since we have no idea what the user
 930                # may have configured as the shell path.
 931                test -x "$1" ||
 932                test "#!" = "$(head -c 2 <"$1")" ||
 933                return;
 934
 935                base=$(basename "$1")
 936                symlink_target=$GIT_BUILD_DIR/$base
 937                # do not override scripts
 938                if test -x "$symlink_target" &&
 939                    test ! -d "$symlink_target" &&
 940                    test "#!" != "$(head -c 2 < "$symlink_target")"
 941                then
 942                        symlink_target=../valgrind.sh
 943                fi
 944                case "$base" in
 945                *.sh|*.perl)
 946                        symlink_target=../unprocessed-script
 947                esac
 948                # create the link, or replace it if it is out of date
 949                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 950        }
 951
 952        # override all git executables in TEST_DIRECTORY/..
 953        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 954        mkdir -p "$GIT_VALGRIND"/bin
 955        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 956        do
 957                make_valgrind_symlink $file
 958        done
 959        # special-case the mergetools loadables
 960        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 961        OLDIFS=$IFS
 962        IFS=:
 963        for path in $PATH
 964        do
 965                ls "$path"/git-* 2> /dev/null |
 966                while read file
 967                do
 968                        make_valgrind_symlink "$file"
 969                done
 970        done
 971        IFS=$OLDIFS
 972        PATH=$GIT_VALGRIND/bin:$PATH
 973        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 974        export GIT_VALGRIND
 975elif test -n "$GIT_TEST_INSTALLED" ; then
 976        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 977        error "Cannot run git from $GIT_TEST_INSTALLED."
 978        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 979        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 980else # normal case, use ../bin-wrappers only unless $with_dashes:
 981        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 982        if ! test -x "$git_bin_dir/git" ; then
 983                if test -z "$with_dashes" ; then
 984                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 985                fi
 986                with_dashes=t
 987        fi
 988        PATH="$git_bin_dir:$PATH"
 989        GIT_EXEC_PATH=$GIT_BUILD_DIR
 990        if test -n "$with_dashes" ; then
 991                PATH="$GIT_BUILD_DIR:$PATH"
 992        fi
 993fi
 994GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 995unset GIT_CONFIG
 996GIT_CONFIG_NOSYSTEM=1
 997GIT_ATTR_NOSYSTEM=1
 998export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 999
1000. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
1001
1002if test -z "$GIT_TEST_CMP"
1003then
1004        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1005        then
1006                GIT_TEST_CMP="$DIFF -c"
1007        else
1008                GIT_TEST_CMP="$DIFF -u"
1009        fi
1010fi
1011
1012GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1013export GITPERLLIB
1014test -d "$GIT_BUILD_DIR"/templates/blt || {
1015        error "You haven't built things yet, have you?"
1016}
1017
1018if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1019then
1020        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1021        export GITPYTHONLIB
1022        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1023                error "You haven't built git_remote_helpers yet, have you?"
1024        }
1025fi
1026
1027if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1028        echo >&2 'You need to build test-chmtime:'
1029        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1030        exit 1
1031fi
1032
1033# Test repository
1034test="trash directory.$(basename "$0" .sh)"
1035test -n "$root" && test="$root/$test"
1036case "$test" in
1037/*) TRASH_DIRECTORY="$test" ;;
1038 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1039esac
1040test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1041rm -fr "$test" || {
1042        GIT_EXIT_OK=t
1043        echo >&5 "FATAL: Cannot prepare test area"
1044        exit 1
1045}
1046
1047HOME="$TRASH_DIRECTORY"
1048export HOME
1049
1050test_create_repo "$test"
1051# Use -P to resolve symlinks in our working directory so that the cwd
1052# in subprocesses like git equals our $PWD (for pathname comparisons).
1053cd -P "$test" || exit 1
1054
1055this_test=${0##*/}
1056this_test=${this_test%%-*}
1057for skp in $GIT_SKIP_TESTS
1058do
1059        case "$this_test" in
1060        $skp)
1061                say_color skip >&3 "skipping test $this_test altogether"
1062                skip_all="skip all tests in $this_test"
1063                test_done
1064        esac
1065done
1066
1067# Provide an implementation of the 'yes' utility
1068yes () {
1069        if test $# = 0
1070        then
1071                y=y
1072        else
1073                y="$*"
1074        fi
1075
1076        while echo "$y"
1077        do
1078                :
1079        done
1080}
1081
1082# Fix some commands on Windows
1083case $(uname -s) in
1084*MINGW*)
1085        # Windows has its own (incompatible) sort and find
1086        sort () {
1087                /usr/bin/sort "$@"
1088        }
1089        find () {
1090                /usr/bin/find "$@"
1091        }
1092        sum () {
1093                md5sum "$@"
1094        }
1095        # git sees Windows-style pwd
1096        pwd () {
1097                builtin pwd -W
1098        }
1099        # no POSIX permissions
1100        # backslashes in pathspec are converted to '/'
1101        # exec does not inherit the PID
1102        test_set_prereq MINGW
1103        test_set_prereq SED_STRIPS_CR
1104        ;;
1105*CYGWIN*)
1106        test_set_prereq POSIXPERM
1107        test_set_prereq EXECKEEPSPID
1108        test_set_prereq NOT_MINGW
1109        test_set_prereq SED_STRIPS_CR
1110        ;;
1111*)
1112        test_set_prereq POSIXPERM
1113        test_set_prereq BSLASHPSPEC
1114        test_set_prereq EXECKEEPSPID
1115        test_set_prereq NOT_MINGW
1116        ;;
1117esac
1118
1119test -z "$NO_PERL" && test_set_prereq PERL
1120test -z "$NO_PYTHON" && test_set_prereq PYTHON
1121test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1122test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1123
1124# Can we rely on git's output in the C locale?
1125if test -n "$GETTEXT_POISON"
1126then
1127        GIT_GETTEXT_POISON=YesPlease
1128        export GIT_GETTEXT_POISON
1129        test_set_prereq GETTEXT_POISON
1130else
1131        test_set_prereq C_LOCALE_OUTPUT
1132fi
1133
1134# Use this instead of test_cmp to compare files that contain expected and
1135# actual output from git commands that can be translated.  When running
1136# under GETTEXT_POISON this pretends that the command produced expected
1137# results.
1138test_i18ncmp () {
1139        test -n "$GETTEXT_POISON" || test_cmp "$@"
1140}
1141
1142# Use this instead of "grep expected-string actual" to see if the
1143# output from a git command that can be translated either contains an
1144# expected string, or does not contain an unwanted one.  When running
1145# under GETTEXT_POISON this pretends that the command produced expected
1146# results.
1147test_i18ngrep () {
1148        if test -n "$GETTEXT_POISON"
1149        then
1150            : # pretend success
1151        elif test "x!" = "x$1"
1152        then
1153                shift
1154                ! grep "$@"
1155        else
1156                grep "$@"
1157        fi
1158}
1159
1160# test whether the filesystem supports symbolic links
1161ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1162rm -f y
1163
1164# When the tests are run as root, permission tests will report that
1165# things are writable when they shouldn't be.
1166test -w / || test_set_prereq SANITY